<template>
  <checkauto-layout>
    <AppBreadcrumbs
      slot="line-breadcrumb"
      :breadcrumbs="breadcrumbs"/>

    <div
      slot="line-content"
      class="kit outer">
      <div class="kit view checkauto report">
        <div class="top flexline">
          <div class="heading">
            <h1>Отчёт проверки авто
              <span class="vin-wrap">по VIN {{ info.Vin }}</span>
            </h1>
            <div class="date-wrap ">Дата проверки: {{ vinRequest.createdAt | dateFormat }}</div>
          </div>
          <div
            v-if="fullReportReady"
            class="print-button">
            <a
              v-if="!$cookies.get('checkautoNoDownloadBtn')"
              :href="`/check-auto/pdf/${vinRequest.id}`"
              class="print aqualink">
              <span class="desktopshow">Печать&nbsp;/&nbsp;</span>PDF
              <img
                svg-inline
                src="~/assets/svg/icons/printer.svg">
            </a>
            <a
              v-else
              :href="`/check-auto/pdf/${vinRequest.id}`"
              target="_blank"
              class="print aqualink">
              <span class="desktopshow">Печать</span>
              <img
                svg-inline
                src="~/assets/svg/icons/printer.svg">
            </a>
          </div>
        </div>

        <report
          v-if="fullReportReady"
          :info="info"
          :full="true"
          @onRestrictionUpdate="loadCaptcha"/>
        <template v-else>
          <div class="ui segment">
            <div class="ui active inverted dimmer">
              <div class="ui text loader">Loading</div>
            </div>
            <p>
              Ваш отчет в процессе подготовки,&nbsp;возможное время ожидания не более 15 минут.&nbsp;Благодарим за
              терпение.
            </p>
          </div>
        </template>

        <div class="bottom">
          <div class="flexline">
            <template v-if="fullReportReady">
              <a
                v-if="!$cookies.get('checkautoNoDownloadBtn')"
                :href="`/check-auto/pdf/${vinRequest.id}`"
                class="ui button circular yellow">
                Скачать <span class="mobilshow">pdf</span> отчет
              </a>
              <a
                v-else
                :href="`/check-auto/pdf/${vinRequest.id}`"
                target="_blank"
                class="ui button circular yellow">
                Печать
              </a>
            </template>
            <payment v-model="paymentSystem.code"/>
          </div>
        </div>

      </div>
    </div>

    <div slot="line-modal">
      <sui-modal
        v-model="captcha.show"
        :animation-duration="1"
        v-dom-move
        v-scroll-lock="captcha.show">
        <i
          class="icon close"
          @click="hideCaptcha"/>
        <div class="header white"/>
        <div class="content">
          <div class="ui form">
            <div
              v-if="captcha.image !== null"
              class="kit text center field">
              <img
                @click="loadCaptcha"
                :src="captcha.image">
            </div>
            <div class="field">
              <div class="ui input">
                <input
                  ref="inputCode"
                  maxlength="5"
                  @keyup.enter="onCodeEnter"
                  type="text"
                  v-model="captcha.code"
                  placeholder="Введите код">
              </div>
            </div>
          </div>
        </div>
        <div class="actions white">
          <button
            class="ui button yellow circular inmodal"
            type="button"
            @click="sendCaptcha"
            :disabled="flag.sending||!validateCode">Отправить
          </button>
        </div>

      </sui-modal>
    </div>
  </checkauto-layout>

</template>

<script>
import { has } from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';

import CheckautoLayout from '~/components/check-auto/main-layout';
import Payment from '~/components/redesign/blocks/payment';
import Report from '~/components/redesign/check-auto/CheckAutoReport';
import AppBreadcrumbs from '~/components/redesign/app-breadcrumbs';

import { SHOW } from '~/assets/js/store/infoModal/action-types';
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/check-auto/full-report';

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
export default {
  name: 'FullReportIdIndex',
  components: {
    AppBreadcrumbs,
    report: Report,
    CheckautoLayout,
    Payment,
  },
  mixins: [SeoMixin, SeoPageMixin],
  asyncData({ app, params }) {
    return app.$axios.$get('/_main/checkauto/fullReportInfo', { params: { id: params.id } })
      .then(({ data }) => ({
        vinRequest: data.vinRequest,
        info: data.info,
        fullReportReady: data.fullReportReady,
        paymentSuccess: data.paymentSuccess,
        paymentSystem: data.paymentSystem,
      }))
      .catch(e => console.error(e));
  },
  data() {
    return {
      flag: {
        sending: false,
      },
      captcha: {
        show: false,
        code: null,
        image: null,
        session: null,
      },
    };
  },
  computed: {
    validateCode() {
      return this.captcha.code !== null && this.captcha.code.match(/^\d{5}$/);
    },
    breadcrumbs() {
      return [
        {
          url: '/check-auto',
          name: 'Проверка авто',
        },
        {
          url: '',
          name: `${(this.info && this.info.Vin) ? this.info.Vin : ''}`,
        },
      ];
    },
  },
  watch: {
    'captcha.show'() {
      this.$nextTick(() => {
        this.$refs.inputCode.focus();
      });
    },
  },
  mounted() {
    if (!this.fullReportReady) {
      this.refresh();
    }
  },
  methods: {
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    refresh() {
      setTimeout(() => {
        this.checkReady();
      }, 5000);
    },
    checkReady() {
      this.$axios.$get('/_main/checkauto/fullReportInfo', { params: { id: this.$route.params.id } })
        .then(({ data }) => {
          if (data.fullReportReady) {
            this.vinRequest = data.vinRequest;
            this.info = data.info;
            this.fullReportReady = data.fullReportReady;
            this.paymentSuccess = data.paymentSuccess;
            this.paymentSystem = data.paymentSystem;
          } else {
            this.refresh();
          }
        })
        .catch(() => {
          this.refresh();
        });
    },
    showCaptcha(image, session) {
      this.captcha.image = image;
      this.captcha.session = session;
      this.captcha.code = '';
      this.captcha.show = true;
    },
    hideCaptcha() {
      this.captcha.show = false;
    },
    onCodeEnter() {
      this.sendCaptcha();
    },
    loadCaptcha() {
      this.updateRestrictions(null, null);
    },
    sendCaptcha() {
      if (this.validateCode) {
        this.updateRestrictions(this.captcha.code, this.captcha.session);
      }
    },
    updateRestrictions(code, session) {
      this.flag.sending = true;
      this.$axios.$post('/_main/checkauto/updateRestrictions', {
        id: this.vinRequest.vinRequestData.id,
        captcha: code,
        session,
      })
        .then(({ data }) => {
          if (data.success) {
            this.hideCaptcha();
            this.checkReady();
          } else {
            this.hideCaptcha();
            if (data.captcha !== null) {
              this.showCaptcha(data.captcha, data.session);
            }
          }
        })
        .catch((xhr) => {
          this.hideCaptcha();
          const { data } = xhr.response;
          if (has(data, 'message') && data.message) {
            this.showInfo({
              text: data.message,
              buttonVisible: false,
            });
          }
        })
        .finally(() => {
          this.flag.sending = false;
        });
    },
  },
};
</script>

<style scoped lang="postcss">
  .kit.view.checkauto.report {
    background-color: #fff;
    .print-button {
      .print {
        font-size: 0.8125rem;
        line-height: calc(1.3125rem * 1.3);
        display: flex;
        align-items: center;
        .svg {
          width: 1.0625rem;
          fill: #669ED9;
          margin-left: 0.5rem;
        }
        // i.icon {
        //   font-size: 1.125rem;
        //   line-height: 1.125rem;
        // }
        @media only screen and (max-width: 980px) {
          font-size: 0.9375rem;
          margin-top: 1rem;
        }
      }
    }
  }
</style>
